/*****************************************************************************/
/*                                                                           */
/*    -----------------------------------------------                        */
/*    df_prnet.h  -  Includefile fuer df_prnet Board-Treiber                 */
/*    unter Linux                                                            */
/*    Version 1.0                                                            */
/*    -----------------------------------------------                        */
/*                                                                           */
/*    ---------------------------------                                      */
/*    COMSOFT  GmbH                                                          */
/*    Wachhausstr. 5a                                                        */
/*    7500 Karlsruhe 41                                                      */
/*    Tel.  0721 / 40908-0 ( Zentrale )                                      */
/*    ---------------------------------                                      */
/*                                                                           */
/*    ------------------------------------                                   */
/*    Datum : 27.01.2015  Weber, Wolfgang                                    */
/*    ------------------------------------                                   */
/*                                                                           */
/*    ------------------------------------------------------------           */
/*    Geaendert : 24.04.2015        Name : Weber, Wolfgang                   */
/*    Grund     :                                                            */
/*    ------------------------------------------------------------           */
/*                                                                           */
/*****************************************************************************/


#define MAX_BOARDS      8
#define  FALSE          0

#ifndef TRUE
  #define  TRUE         1
#endif
#define  NOT_INIT       1

#define STATUS_NOT_SUPPORTED  -1

#define jiffies_from_ms(a)    msecs_to_jiffies(a)

typedef struct _DESC_PCI_
{
   unsigned int   pci_irq_line; 
   unsigned int   pci_ioaddr; 
   unsigned int   pci_io_size; 
   unsigned int   pci_memaddr;
   unsigned long  pci_mem_size;
   caddr_t        virt_board_addr;
   caddr_t        virt_base_addr;
   caddr_t        virt_io_addr;
   void           *cpu_addr;
   dma_addr_t     dma_handle;
   size_t         dma_mem_size; 
   char           init;
      
}  DESC_PCI;



#define  DEV    (dev-1)
#define  SS_NR  1

#define E_100           -100
#define E_101           -101
#define E_102           -102
#define E_103           -103
#define E_104           -104
#define E_105           -105
#define E_106           -106
#define E_107           -107
#define E_108           -108
#define E_109           -109
#define E_110           -110
#define E_111           -111
#define E_112           -112
#define E_113           -113
#define E_114           -114
#define E_120           -120
#define E_121           -121
#define E_122           -122
#define E_123           -123
#define E_124           -124
#define E_125           -125
#define E_126           -126
#define E_127           -127
#define E_130           -130
#define E_131           -131
#define E_132           -132
#define E_140           -140
#define E_141           -141
#define E_150           -150

#define STATUS_SUCCESS  0

void           df_prnet_memory_dump            ( unsigned char *ptr, unsigned int len, char* buffer );
void           df_prnet_memory_dump_reverse    ( unsigned char *ptr, unsigned int len );
void           df_prnet_do_tasklet             ( unsigned long instance );
int            df_prnet_ioctl_switch           ( void *instance,  const void * usr_addr );
void *         df_prnet_initiate_register( void *maininstance, DESC_PCI *pdesc );
unsigned int   df_prnet_initiate_unregister (void *instance);

unsigned int   df_prnet_irq (void *instance);

void           df_prnet_wake_up_we_ctl_acyclic( void *maininstance );
void           df_prnet_wake_up_we_dev_acyclic( void *maininstance );
int            df_prnet_wait_event_irp_we_ctl_acyclic( void *maininstance, long timeout );
int            df_prnet_wait_event_irp_we_dev_acyclic( void *maininstance, long timeout );

void           KeStallExecutionProcessor(unsigned long dma_wait_stall_time_us);

int copyin(  void *dest, const void  *source, unsigned long len );
int copyout( void *dest, const void  *source, unsigned long len );

void * df_prnet_calloc(unsigned long length);
void df_prnet_free(void *);

int df_prnet_ctl_acyc_down_int( void *maininstance );
int df_prnet_ctl_cyc_down_int( void *maininstance );
int df_prnet_dev_acyc_down_int( void *maininstance);
int df_prnet_dev_cyc_down_int( void *maininstance );
void df_prnet_ctl_acyc_up( void *maininstance );
void df_prnet_ctl_cyc_up( void *maininstance );
void df_prnet_dev_acyc_up( void *maininstance );
void df_prnet_dev_cyc_up( void *maininstance );

///-----------------------------------------------------------------------------------
