//+=============================================================================================
//|
//!    \file common_define.h
//!    This file defines global data types and constants as well as other global definitions.
//|
//+---------------------------------------------------------------------------------------------
//|
//|    File-ID:    $Id: common_define.h 30125 2017-05-15 12:05:24Z cvogt $
//|    Location:   $URL: http://srv-kunbus10/svn/ICP/ESD/700361_Profinet_IO_Controller/dev/Linux_Driver/trunk/common_define.h $
//|    Copyright:  KUNBUS GmbH
//|
//+=============================================================================================
#ifndef _COMMON_DEFINE_H_
#define _COMMON_DEFINE_H_

#include <linux/types.h>

typedef uint8_t             INT8U;    ///< 8 Bit unsigned integer
typedef int8_t              INT8S;    ///< 8 Bit signed integer
typedef uint16_t            INT16U;   ///< 16 Bit unsigned integer
typedef int16_t             INT16S;   ///< 16 Bit signed integer
typedef uint32_t            INT32U;   ///< 32 Bit unsigned integer
typedef int32_t             INT32S;   ///< 32 Bit signed integer
typedef uint64_t            INT64U;   ///< 64 Bit unsigned integer
typedef int64_t             INT64S;   ///< 64 Bit signed integer
typedef float               FLOAT32;  ///< 32 Bit signed floating point
typedef double              FLOAT64;  ///< 64 Bit signed floating point
typedef uint8_t             TBOOL;    ///< Boolean value (bTRUE/bFALSE)
typedef unsigned char       CHAR8U;   ///< 8 Bit unsigned character
typedef signed char         CHAR8S;   ///< 8 Bit signed character
typedef char                CHAR8;    ///< 8 Bit character


#else   // _COMMON_DEFINE_H_
//  #pragma message "_COMMON_DEFINE_H_ already defined !"
#endif   // _COMMON_DEFINE_H_
